{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit DBorHSExportToFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

type
  TDBorHSExportToForm = class(TForm)
    ExportButton: TButton;
    CancelButton: TButton;
    SaveHTMLDialog: TSaveDialog;
    SaveTextDialog: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    FromSpinEdit: TSpinEdit;
    ToSpinEdit: TSpinEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    WholeTableRadioButton: TRadioButton;
    PartRadioButton: TRadioButton;
    TextRadioButton: TRadioButton;
    HTMLRadioButton: TRadioButton;
    procedure WholeTableRadioButtonClick(Sender: TObject);
    procedure PartRadioButtonClick(Sender: TObject);
    procedure TextRadioButtonClick(Sender: TObject);
    procedure HTMLRadioButtonClick(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DBorHSExportToForm: TDBorHSExportToForm;

implementation

uses DatabaseShowingFormUnit, HighScoresUnit, TestTypesConstantsVariables;

{$R *.dfm}

procedure TDBorHSExportToForm.WholeTableRadioButtonClick(Sender: TObject);
begin
  FromSpinEdit.Enabled:=false;
  ToSpinEdit.Enabled:=false;
  PartRadioButton.Checked:=false;
end;

procedure TDBorHSExportToForm.PartRadioButtonClick(Sender: TObject);
begin
  FromSpinEdit.Enabled:=true;
  ToSpinEdit.Enabled:=true;
  WholeTableRadioButton.Checked:=false;
end;

procedure TDBorHSExportToForm.TextRadioButtonClick(Sender: TObject);
begin
  HTMLRadioButton.Checked:=false;
end;

procedure TDBorHSExportToForm.HTMLRadioButtonClick(Sender: TObject);
begin
  TextRadioButton.Checked:=false;
end;

procedure TDBorHSExportToForm.ExportButtonClick(Sender: TObject);
var
 i: cardinal;
 f: textfile;
begin
 if TextRadioButton.Checked then
  if SaveTextDialog.Execute then
   begin
    AssignFile(f,SaveTeXTDialog.FileName+'.txt');
    Reset(f);
    if IOResult=0 then
     if MessageDLG('   . ?',mtWarning,mbYesNoCancel,0)in[mrNo,mrCancel] then Exit;
    Rewrite(f);
    if WholeTableRadioButton.Checked then
     begin
     if SenderOfExportDBHS=0 then
      begin
       Rewrite(f);
       for i:=1 to DataBaseShowingForm.StringGrid.RowCount do
        begin
         Writeln(f,' '+inttostr(i)+':');
         Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[0,i]+#13+'  : '+ DataBaseShowingForm.StringGrid.Cells[1,i]+#13+'  : '+
                   DataBaseShowingForm.StringGrid.Cells[2,i]+#13+'  -  : '+DataBaseShowingForm.StringGrid.Cells[3,i]+#13+'   : '+
                   DataBaseShowingForm.StringGrid.Cells[4,i]+#13+'   : '+DataBaseShowingForm.StringGrid.Cells[5,i]+#13+'   :'+
                   DataBaseShowingForm.StringGrid.Cells[6,i]);
        end;
       CloseFile(f);
      end
     else
      begin
       Rewrite(f);
       for i:=1 to HighScoresForm.StringGrid.RowCount do
        begin
         Writeln(f,' '+inttostr(i)+':');
         Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[1,i]+#13+'  : '+ HighScoresForm.StringGrid.Cells[2,i]+#13+'  : '+
                   HighScoresForm.StringGrid.Cells[3,i]+#13+'  -  : '+HighScoresForm.StringGrid.Cells[4,i]+#13+'   : '+
                   HighScoresForm.StringGrid.Cells[5,i]);
        end;
       CloseFile(f);
      end;
     end
    else
     begin
     if SenderOfExportDBHS=0 then
      begin
       Rewrite(f);
       for i:=FromSpinEdit.Value to ToSpinEdit.Value do
        begin
         Writeln(f,' '+inttostr(i)+':');
         Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[0,i]+#13+'  : '+ DataBaseShowingForm.StringGrid.Cells[1,i]+#13+'  : '+
                   DataBaseShowingForm.StringGrid.Cells[2,i]+#13+'  -  : '+DataBaseShowingForm.StringGrid.Cells[3,i]+#13+'   : '+
                   DataBaseShowingForm.StringGrid.Cells[4,i]+#13+'   : '+DataBaseShowingForm.StringGrid.Cells[5,i]+#13+'   :'+
                   DataBaseShowingForm.StringGrid.Cells[6,i]);
        end;
       CloseFile(f);
      end
     else
      begin
       Rewrite(f);
       for i:=FromSpinEdit.Value to ToSpinEdit.Value do
        begin
         Writeln(f,' '+inttostr(i)+':');
         Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[1,i]+#13+'  : '+ HighScoresForm.StringGrid.Cells[2,i]+#13+'  : '+
                   HighScoresForm.StringGrid.Cells[3,i]+#13+'  -  : '+HighScoresForm.StringGrid.Cells[4,i]+#13+'   : '+
                   HighScoresForm.StringGrid.Cells[5,i]);
        end;
       CloseFile(f);
      end;
     end;
    Close;
   end;
 if HTMLRadioButton.Checked then
  if SaveHTMLDialog.Execute then
   begin
    AssignFile(f,SaveHTMLDialog.FileName+'.html');
    Reset(f);
    if IOResult=0 then
     if MessageDLG('   . ?',mtWarning,mbYesNoCancel,0)in[mrNo,mrCancel] then Exit;
    Rewrite(f);
    Writeln(f,'<!--    Mental Control 1.0 -->');
    Writeln(f,'<HTML>');
    Writeln(f,'<HEAD>');
    Writeln(f,'<TITLE>');
    Writeln(f,'   Mental Control');
    Writeln(f,'</TITLE>');
    Writeln(f,'<BODY>');
    if WholeTableRadioButton.Checked then
     begin
      if SenderOfExportDBHS=0 then
       begin
        for i:=1 to DataBaseShowingForm.StringGrid.RowCount do
         begin
          Writeln(f,'<P>');
          Writeln(f,' '+inttostr(i)+':');
          Writeln(f,'<P>');
          Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[0,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+ DataBaseShowingForm.StringGrid.Cells[1,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[2,i]);
          Writeln(f,'<P>');
          Writeln(f,'  -  : '+DataBaseShowingForm.StringGrid.Cells[3,i]);
          Writeln(f,'<P>');
          Writeln(f,'   : '+DataBaseShowingForm.StringGrid.Cells[4,i]);
          Writeln(f,'<P>');
          Writeln(f,'   : '+DataBaseShowingForm.StringGrid.Cells[5,i]);
          Writeln(f,'<P>');
          Writeln(f,'   :'+DataBaseShowingForm.StringGrid.Cells[6,i]);
          Writeln(f,'<P>');
        end;
       end
      else
       begin
        for i:=1 to HighScoresForm.StringGrid.RowCount do
         begin
          Writeln(f,'<P>');
          Writeln(f,' '+inttostr(i)+':');
          Writeln(f,'<P>');
          Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[1,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+ HighScoresForm.StringGrid.Cells[2,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[3,i]);
          Writeln(f,'<P>');
          Writeln(f,'  -  : '+HighScoresForm.StringGrid.Cells[4,i]);
          Writeln(f,'<P>');
       end;
      end;
     end
    else
     begin
      if SenderOfExportDBHS=0 then
       begin
        for i:=FromSpinEdit.Value to ToSpinEdit.Value do
         begin
          Writeln(f,'<P>');
          Writeln(f,' '+inttostr(i)+':');
          Writeln(f,'<P>');
          Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[0,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+ DataBaseShowingForm.StringGrid.Cells[1,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+DataBaseShowingForm.StringGrid.Cells[2,i]);
          Writeln(f,'<P>');
          Writeln(f,'  -  : '+DataBaseShowingForm.StringGrid.Cells[3,i]);
          Writeln(f,'<P>');
          Writeln(f,'   : '+DataBaseShowingForm.StringGrid.Cells[4,i]);
          Writeln(f,'<P>');
          Writeln(f,'   : '+DataBaseShowingForm.StringGrid.Cells[5,i]);
          Writeln(f,'<P>');
          Writeln(f,'   :'+DataBaseShowingForm.StringGrid.Cells[6,i]);
          Writeln(f,'<P>');
        end;
       end
      else
       begin
        for i:=FromSpinEdit.Value to ToSpinEdit.Value do
         begin
          Writeln(f,'<P>');
          Writeln(f,' '+inttostr(i)+':');
          Writeln(f,'<P>');
          Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[1,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+ HighScoresForm.StringGrid.Cells[2,i]);
          Writeln(f,'<P>');
          Writeln(f,'  : '+HighScoresForm.StringGrid.Cells[3,i]);
          Writeln(f,'<P>');
          Writeln(f,'  -  : '+HighScoresForm.StringGrid.Cells[4,i]);
          Writeln(f,'<P>');
          Writeln(f,'   : '+HighScoresForm.StringGrid.Cells[5,i]);
          Writeln(f,'<P>');
       end;
     end;
    Writeln(f,'</BODY>');
    Writeln(f,'</HTML>');
    CloseFile(f);
   end;
    Close;
   end;
end;

procedure TDBorHSExportToForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TDBorHSExportToForm.FormCreate(Sender: TObject);
begin
  TextRadioButton.Checked:=true;
  FromSpinEdit.Enabled:=false;
  ToSpinEdit.Enabled:=false;
end;

procedure TDBorHSExportToForm.FormPaint(Sender: TObject);
begin
  if SenderOfExportDBHS=0 then
   begin
    FromSpinEdit.MaxValue:=DatabaseShowingForm.StringGrid.RowCount;
    ToSpinEdit.MaxValue:=DatabaseShowingForm.StringGrid.RowCount;
   end
  else
   begin
    FromSpinEdit.MaxValue:=HighScoresForm.StringGrid.RowCount;
    ToSpinEdit.MaxValue:=HighScoresForm.StringGrid.RowCount;
   end;
end;

end.
