{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit DatabaseOptionsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TDatabaseOptionsForm = class(TForm)
    DBAddCheckBox: TCheckBox;
    DBHighscoresCheckBox: TCheckBox;
    DBShowCheckBox: TCheckBox;
    DBCallUserCheckBox: TCheckBox;
    OKButton: TButton;
    ClearDBButton: TButton;
    ClearHighscoresButton: TButton;
    DefaultETCbutton: TButton;
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ClearDBButtonClick(Sender: TObject);
    procedure ClearHighscoresButtonClick(Sender: TObject);
    procedure DefaultETCbuttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DatabaseOptionsForm: TDatabaseOptionsForm;

implementation

uses TestTypesConstantsVariables, TestServices;

{$R *.dfm}

procedure TDatabaseOptionsForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TDatabaseOptionsForm.OKButtonClick(Sender: TObject);
begin
  TestOptions.ToAddAllResultsToDatabase:=DBAddCheckBox.Checked;
  TestOptions.ToCreateHighscoresList:=DBHighscoresCheckBox.Checked;
  TestOptions.ToShowDatabaseAfterEveryTesting:=DBShowCheckBox.Checked;
  TestOptions.ToCallUserNameFoEveryTesting:=DBCallUserCheckBox.Checked;
  Close;
end;

procedure TDatabaseOptionsForm.FormPaint(Sender: TObject);
begin
  DBAddCheckBox.Checked:=TestOptions.ToAddAllResultsToDatabase;
  DBHighScoresCheckBox.Checked:=TestOptions.ToCreateHighscoresList;
  DBShowCheckBox.Checked:=TestOptions.ToShowDatabaseAfterEveryTesting;
  DBCallUserCheckBox.Checked:=TestOptions.ToCallUserNameFoEveryTesting;
end;

procedure TDatabaseOptionsForm.ClearDBButtonClick(Sender: TObject);
var
  p: PChar;
begin
  if MessageDLG(' ?',mtConfirmation,[mbYes, mbNo],0)=mrNo then Exit;
    p:=PChar(ExtractFilePath(ParamStr(0)));
  if not  DeleteFile(String(p)+'\Mental Control\Second.auf') then
    MessageDLG('  :   ',mtError,[mbOK],0)
  else MessageDLG('   !',mtInformation,[mbOK],0);
end;

procedure TDatabaseOptionsForm.ClearHighscoresButtonClick(Sender: TObject);
var
  p: PChar;
begin
  if MessageDLG(' ?',mtConfirmation,[mbYes, mbNo],0)=mrNo then Exit;
    p:=PChar(ExtractFilePath(ParamStr(0)));
  if not  DeleteFile(String(p)+'\Mental Control\Third.auf') then
    MessageDLG('  :    ',mtError,[mbOK],0)
  else MessageDLG('   !',mtInformation,[mbOK],0);
end;

procedure TDatabaseOptionsForm.DefaultETCbuttonClick(Sender: TObject);
begin
  if MessageDLG('       ,   .',mtConfirmation,[mbYes,mbNo],0)=mrNo then Exit;
  TestServices.SetDBOptionsDefault;
  Refresh;
end;

end.
