{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit DeleteQuestionNFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TDeleteQuestionNForm = class(TForm)
    OKButton: TButton;
    Label1: TLabel;
    SpinEdit: TSpinEdit;
    CancelButton: TButton;
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DeleteQuestionNForm: TDeleteQuestionNForm;

implementation

uses TestTypesConstantsVariables, MainTestUnit, ShowQuestionNFormUnit,
  ShowAnswerNFormUnit, MediaPlayerFormUnit,
  CurrentAnswerVariantEditingFormUnit;

{$R *.dfm}

procedure TDeleteQuestionNForm.OKButtonClick(Sender: TObject);
var
  i: word;
  b: word;
begin
  if not Editing then Close;
  if CurrentTestOptions.QuestionsCount = 1 then
   begin
    MessageDLG('     1 !',mtError,[mbOK],0);
    Close;
    Exit;
   end;
  b:=spinedit.value-1;
  for i:=b to CurrentTestOptions.QuestionsCount-2 do
    Questions[i]:=Questions[i+1];
  Dec(CurrentTestOptions.QuestionsCount,1);
  SetLength(Questions,CurrentTestoptions.QuestionsCount);
  CurrentEditingQuestion:=0;
  CurrentEditingAnswer:=0;
  with TestMainForm do
  begin
    QuestionTextEdit.Text:=Questions[CurrentEditingQuestion].Question;
    AnswerVariantsCountSpinEdit.Value:=Questions[CurrentEditingQuestion].AnsCount;
    if Questions[CurrentEditingQuestion].PicturePath='' then ChoosePictureEdit.text:='<None>' else
     begin
       ChoosePictureEdit.text:=Questions[CurrentEditingQuestion].PicturePath;
       Image.picture.LoadFromFile(Questions[CurrentEditingQuestion].PicturePath);
     end;
    LoopSoundCheckBox.Checked:=Questions[CurrentEditingQuestion].LoopSound;
    CurrentAnswerVariantEditingForm.BallsForvariantSpinEdit.Value:=Questions[CurrentEditingQuestion].Balls[CurrentEditingAnswer];
    CurrentAnswerVariantEditingForm.HintEdit.Text:=Questions[CurrentEditingQuestion].Hint[CurrentEditingAnswer];
    CurrentAnswerVariantEditingForm.CommentEdit.Text:=Questions[CurrentEditingQuestion].Comment[CurrentEditingAnswer];
  end;
  if CurrentEditingQuestion = 0 then TestMainForm.PreviousQuestionButton.Enabled:=false else TestMainForm.PreviousQuestionButton.Enabled:=true;
  if CurrentEditingQuestion = CurrentTestOptions.QuestionsCount-1 then TestMainForm.NextQuestionButton.Enabled:=false else TestMainForm.NextQuestionButton.Enabled:=true;
  TestMainForm.NumberOfQuestionLabel.Caption:=IntToStr(1+CurrentEditingQuestion)+' question';
  TestMainForm.NumberOfAnswerVariantLabel.Caption:=IntToStr(1+CurrentEditingAnswer)+' Answer Variant';
  CurrentAnswerVariantEditingForm.AnswerVariantTextEdit.Text:=Questions[CurrentEditingQuestion].Answer[CurrentEditingAnswer];
  CurrentAnswerVariantEditingForm.RightAnswerCheckBox.Checked:=Questions[CurrentEditingQuestion].Right[CurrentEditingAnswer];
  CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Value:=Questions[CurrentEditingQuestion].Balls[CurrentEditingAnswer];
  CurrentAnswerVariantEditingForm.CommentEdit.Text:=Questions[CurrentEditingQuestion].Comment[CurrentEditingAnswer];
  CurrentAnswerVariantEditingForm.HintEdit.Text:=Questions[CurrentEditingQuestion].Hint[CurrentEditingAnswer];
  CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=Questions[CurrentEditingQuestion].HintMinusBalls[CurrentEditingAnswer];
  if CurrentEditingAnswer=0 then TestMainForm.PreviousAnswerVariantButton.Enabled:=false else TestMainForm.PreviousAnswerVariantButton.Enabled:=true;
  if CurrentEditingAnswer=Questions[CurrentEditingQuestion].AnsCount-1 then TestMainForm.NextAnswerVariantButtonButton.Enabled:=false else TestMainForm.NextAnswerVariantButtonButton.Enabled:=true;
  TestMainForm.NumberOfQuestionLabel.Caption:=IntToStr(1+CurrentEditingQuestion)+' question';
  TestMainForm.NumberOfAnswerVariantLabel.Caption:=IntToStr(1+CurrentEditingAnswer)+' Answer Variant';
  if Questions[CurrentEditingQuestion].SoundPath='' then TestMainForm.ChoosesoundEdit.text:='<None>' else
   begin
    TestMainForm.ChoosePictureEdit.text:=Questions[CurrentEditingQuestion].SoundPath;
    MediaPlayerForm.Show;
    TestMainForm.Repainting;
    MediaPlayerForm.PlayButtonClick(Self);
   end;
  Close;
end;

procedure TDeleteQuestionNForm.FormCreate(Sender: TObject);
begin
  SpinEdit.MaxValue:=CurrentTestOptions.QuestionsCount;
end;

procedure TDeleteQuestionNForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

end.
