{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit ExportToFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TExportToForm = class(TForm)
    ChooseExportingFileFormatLabel: TLabel;
    ExportButton: TButton;
    CancelButton: TButton;
    HTMLSaveDialog: TSaveDialog;
    TextSaveDialog: TSaveDialog;
    ExportFormatComboBox: TListBox;
    CheckRightAnswersCheckBox: TCheckBox;
    WriteHintsCheckBox: TCheckBox;
    WriteCommentsCheckBox: TCheckBox;
    WriteBallsCheckBox: TCheckBox;
    procedure CancelButtonClick(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExportToForm: TExportToForm;

implementation

uses TestTypesConstantsVariables;

{$R *.dfm}

procedure ExportToHTML(Picts: boolean; FileName: TFileName; Hints, Comments, Balls, CheckRight: boolean);
var
 f: TextFile;
 i,j: word;
begin
  i:=0;
  AssignFile(f,FileName);
  Rewrite(f);
  Writeln(f,'<!--    Mental Control 1.0 -->');
  Writeln(f,'<HTML>');
  Writeln(f,'<HEAD>');
  Writeln(f,'<TITLE>');
  Writeln(f, CurrentTestOptions.TopicName);
  Writeln(f,'</TITLE>');
  Writeln(f,'<BODY>');
  Writeln(f,'<H1>');
  Writeln(f, CurrentTestOptions.TopicName);
  Writeln(f,'<P>');
  Writeln(f,'</H1>');
  repeat
   Writeln(f,'<H2>');
   Writeln(f, Questions[i].Question);
   Writeln(f,'</H2>');
   Writeln(f,'<P>');
   Writeln(f,'<H3>');
   if CurrentTestOptions.WithPictures and (Questions[i].PicturePath<>'') and
      Picts then Writeln(f,'<IMG SRC="'+Questions[i].PicturePath+'" ALIGN=LEFT>');
   for j:=0 to Questions[i].AnsCount-1 do
    begin
     Writeln(f, IntToStr(j+1)+') '+Questions[i].Answer[j]);
     Writeln(f, '<P>');
     if (Questions[i].Right[j])and CheckRight then
      begin
       Writeln(f,'<I>');
       Writeln(f,'- -');
       Writeln(f,'</I>');
       Writeln(f,'<P>');
      end;
    if (Questions[i].Hint[j]<>'')and Hints then
      begin
       Writeln(f,'<I>');
       Writeln(f,Questions[i].Hint[j]);
       Writeln(f,'</I>');
       Writeln(f,'<P>');
      end;
     if (Questions[i].Comment[j]<>'')and Comments then
      begin
       Writeln(f,'<I>');
       Writeln(f,Questions[i].Comment[j]);
       Writeln(f,'</I>');
       Writeln(f,'<P>');
      end;
     if (Questions[i].Balls[j]<>0)and Balls then
      begin
       Writeln(f,'<I>');
       Writeln(f,'-:- '+IntToStr(Questions[i].Balls[j]));
       Writeln(f,'</I>');
       Writeln(f,'<P>');
      end;
    end;
   inc(i);
  until i=CurrentTestOptions.QuestionsCount;
  Writeln(f,'</BODY>');
  Writeln(f,'</HTML>');
  CloseFile(f);
end;

procedure ExportToText(FileName: TFileName; Hints, Comments, Balls, CheckRight: boolean);
var
  f: TextFile;
  i,j: word;
begin
  AssignFile(f,FileName);
  Rewrite(f);
  Writeln(f,CurrentTestOptions.TopicName);
  Writeln(f,#13);
  for i:=0 to CurrentTestOptions.QuestionsCount-1 do
   begin
    Writeln(f,Questions[i].Question);
    for j:=0 to Questions[i].AnsCount-1 do
     begin
      Writeln(f,IntToStr(j+1)+') '+Questions[i].Answer[j]);
      if (Questions[i].Hint[j]<>'')and Hints then Writeln(f, '--:-- '+Questions[i].Hint[j]);
      if (Questions[i].Comment[j]<>'')and Comments then Writeln(f, '--:-- '+Questions[i].Comment[j]);
      if (Questions[i].Balls[j]<>0)and Balls then Writeln(f, '--:-- '+IntToStr(Questions[i].Balls[j]));
      if (Questions[i].Right[j])and CheckRight then Writeln(f, '-- --');
     end;
    Writeln(f,#13);
   end;
  CloseFile(f);
end;

procedure TExportToForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TExportToForm.ExportButtonClick(Sender: TObject);
var
  HTML, Picts: Boolean;
  f: file;
  s, s1: string;
label BACK_, BACK__;
begin
  Picts:=false;
  HTML:=false;
  case ExportFormatComboBox.ItemIndex of
   0:    begin
          HTML:=true;
          Picts:=false;
         end;
   1:    begin
          HTML:=true;
          Picts:=true;
         end;
   2:    begin
          HTML:=false;
          Picts:=false;
         end;
  end;
  if HTML then
   begin
    BACK_:
    if HTMLSaveDialog.Execute then
     begin
      s:=HTMLSaveDialog.FileName;
      AssignFile(f,s);
      Reset(f);
      if IOResult=0 then
       if MessageDLG('      ?',mtWarning,[mbYes,mbNo],0)=mrNo then
          goto BACK_;
      CloseFile(f);
      s1:=s[length(s)-4]+s[length(s)-3]+s[length(s)-2]+s[length(s)-1];
      if s1<>'.htm' then s:=s+'.html';
      ExportToHTML(Picts,s,WriteHintsCheckBox.Checked,WriteCommentsCheckBox.Checked,WriteBallsCheckBox.Checked,CheckRightAnswersCheckBox.Checked);
     end;
   end
  else
   begin
    BACK__:
    if TextSaveDialog.Execute then
     begin
      s:=TextSaveDialog.FileName;
      AssignFile(f,s);
      Reset(f);
      if IOResult=0 then
       if MessageDLG('      ?',mtWarning,[mbYes,mbNo],0)=mrNo then
          goto BACK_;
      CloseFile(f);
      s1:=s[length(s)-3]+s[length(s)-2]+s[length(s)-1]+s[length(s)];
      if s1<>'.txt' then s:=s+'.txt';
      ExportToText(s,WriteHintsCheckBox.Checked,WriteCommentsCheckBox.Checked,WriteBallsCheckBox.Checked,CheckRightAnswersCheckBox.Checked);
     end;
   end;
  Close;
end;

end.
