library MCW32RegistryServices;

uses
  Windows,
  Dialogs,
  Forms,
  Messages,
  Registry;

procedure RegPassword(const Psswrd: string); export;
var
{ h: HKEY;
begin
  if RegCreateKey(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot create reg key Psswrds');
    Exit;
   end;
  if RegSetValue(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',REG_SZ,PChar(psswrd),length(psswrd))<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot reg value '+Psswrd);
    Exit;
   end;
  if RegCloseKey(h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot close registry');
    Exit;
   end;}
  r: TRegIniFile;
begin
  R:=TRegIniFile.Create('');
  r.RootKey:=HKEY_LOCAL_MACHINE;
  r.WriteString('SOFTWARE\Mental Control\Psswrds','',psswrd);
  r.CloseKey;
  r.Free;
end;

function LoadPassword: string; export;
var
{  h: HKEY;
  p: PChar;
  r: integer;
begin
  r:=0;
  New(p);
  if RegOpenKey(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot open reg key Psswrds');
    Exit;
   end;
  if RegQueryValue(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',P,r)<>ERROR_SUCCESS then
    begin
     ShowMessage('Cannot open reg value');
     Exit;
    end;
  if RegCloseKey(h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot close registry');
    Exit;
   end;
  Dispose(p);}
  r: TRegIniFile;
begin
  R:=TRegIniFile.Create('');
  r.RootKey:=HKEY_LOCAL_MACHINE;
  Result:=r.ReadString('SOFTWARE\Mental Control\Psswrds','','');
  r.Free;
end;

function PasswordExisting: boolean; export;
var
  h: HKEY;
begin
  Result:=RegOpenKey(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',h)=ERROR_SUCCESS;
end;

procedure RegExtensions(Dir: string); export;
var
  R : TRegIniFile;
begin
  R := TRegIniFile.Create('');
  with R do
   begin
    RootKey := HKEY_CLASSES_ROOT;
    WriteString('.mct','',' Mental Control');
    WriteString(' Mental Control','',' Mental Control');
    WriteString(' Mental Control\DefaultIcon','',Dir+',2');
    WriteString('.tfd','','  Mental Control');
    WriteString('  Mental Control','',' Mental Control');
    WriteString('  Mental Control\DefaultIcon','',Dir+',1');
    Free;
   end;
end;

exports
  RegPassword name 'RegPassword',
  LoadPassword name 'LoadPassword',
  PasswordExisting name 'PasswordExisting',
  RegExtensions name 'RegExtensions';

begin
end.
