{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit TestOptionsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, jpeg, ExtCtrls, Spin;

type
  TTestOptionsForm = class(TForm)
    LimitTimeCheckBox: TCheckBox;
    LimitTimeLabel: TLabel;
    PictureLabel: TLabel;
    ChooseFontButton: TButton;
    ChooseColorButton: TButton;
    OpenPictureDialog: TOpenPictureDialog;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    BackgroundImage: TImage;
    OKButton: TButton;
    LimitTimeSpinEdit: TSpinEdit;
    Label1: TLabel;
    LoadButton: TButton;
    NoneButton: TButton;
    ChangePasswordButton: TButton;
    SetDefaultValuesButton: TButton;
    procedure LimitTimeCheckBoxClick(Sender: TObject);
    procedure NoneButtonClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure ChooseFontButtonClick(Sender: TObject);
    procedure ChooseColorButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ChangePasswordButtonClick(Sender: TObject);
    procedure SetDefaultValuesButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestOptionsForm: TTestOptionsForm;

implementation

uses TestTypesConstantsVariables, TestServices, MainTestUnit,
  OptionsPasswordFormUnit;

{$R *.dfm}

procedure TTestOptionsForm.LimitTimeCheckBoxClick(Sender: TObject);
begin
  if not LimitTimeCheckBox.Checked then
   begin
    LimitTimeSpinEdit.Value:=0;
    LimitTimeSpinEdit.Enabled:=false;
   end
  else
   begin
    LimitTimeSpinEdit.Value:=TestOptions.MaxTestTime;
    LimitTimeSpinEdit.Enabled:=true;
   end;
end;

procedure TTestOptionsForm.NoneButtonClick(Sender: TObject);
begin
   TestOptions1.BackgroundBitmapFilePath:=ExtractFilePath(ParamStr(0))+'\Mcw32EIOperation.ico';
   BackgroundImage.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
   TestMainForm.Image.Picture.LoadFromFile(TestOptions1.BackgroundBitmapFilePath);
end;

procedure TTestOptionsForm.LoadButtonClick(Sender: TObject);
begin
  if OpenPictureDialog.Execute then
   begin
    if OpenPictureDialog.FileName='' then TestOptions.BackgroundBitmapFilePath:=ExtractFilePath(ParamStr(0))+'\Mcw32EIOperation.ico'
    else TestOptions.BackgroundBitmapFilePath:=OpenPictureDialog.FileName;
    BackgroundImage.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
  if IOResult<>0 then
   begin
    TestOptions.BackgroundBitmapFilePath:=ExtractFilePath(ParamStr(0)+'\Mcw32EIOperation.ico');
    BackgroundImage.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
   end;
   end;
end;

procedure TTestOptionsForm.ChooseFontButtonClick(Sender: TObject);
begin
  FontDialog.Font:=ProgFont;
  if FontDialog.Execute then
   begin
    ProgFont:=FontDialog.Font;
    with TestOptions.BackGroungFont do
     begin
      Charset:=ProgFont.Charset;
      Color:=ProgFont.Color;
      Height:=ProgFont.Height;
      Name:=ProgFont.Name;
      Pitch:=ProgFont.Pitch;
      PixelsPerInch:=ProgFont.PixelsPerInch;
      Size:=ProgFont.Size;
      Style:=ProgFont.Style;
     end;
    SetAllFontAndColor;
   end;
end;

procedure TTestOptionsForm.ChooseColorButtonClick(Sender: TObject);
begin
  ColorDialog.Color:=BGColor;
  if ColorDialog.Execute then
   begin
    BGColor:=ColorDialog.Color;
    TestOptions1.BackWindowGroundColor:=BGColor;
    TestOptions:=TestOptions1;
    SetAllFontAndColor;
   end;
end;

procedure TTestOptionsForm.OKButtonClick(Sender: TObject);
begin
  TestOptions.ToLimitTestTime:=LimitTimeCheckBox.Checked;
  TestOptions.MaxTestTime:=LimitTimeSpinEdit.Value;
  TestMainForm.Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
  Close;
end;

procedure TTestOptionsForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TTestOptionsForm.FormPaint(Sender: TObject);
begin
  LimitTimeCheckBox.Checked:=TestOptions.ToLimitTestTime;
  LimitTimeSpinEdit.Enabled:=TestOptions.ToLimitTestTime;
  LimitTimeSpinEdit.Value:=TestOptions.MaxTestTime;
end;

procedure TTestOptionsForm.ChangePasswordButtonClick(Sender: TObject);
begin
  if MessageDLG('    ?',mtConfirmation,[mbYes,mbNo],0)=mrNo then Exit;
  OptionsPasswordForm.PasswordEdit.Text:=LoadPassword;
  OptionsPasswordForm.ShowModal;
  TestPass:=OptionsPasswordForm.PasswordEdit.Text;
  if not RegPsswrdCommand then
   begin
    TestServices.RegPassword(TestPass);
    MessageDLG(' .',mtInformation,[mbOK],0);
   end;
end;

procedure TTestOptionsForm.SetDefaultValuesButtonClick(Sender: TObject);
begin
  if MessageDLG('       ?',mtConfirmation,[mbYes,mbNo],0)=mrNo then Exit;
  TestServices.SetTestOptionsDefault;
  TestMainForm.Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
  SetAllFontAndColor;
  Refresh;
end;

end.
