{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit TestServices;

interface

procedure SetRU;
procedure SetEN;
procedure SetAllFontAndColor;
procedure SaveUndoRedo;
procedure RestoreUndoRedo;
procedure RegPassword(const Psswrd: string);
function LoadPassword: string;
function PasswordExisting: boolean;
procedure StoreQuestions;
procedure RestoreQuestions;
procedure ShowTestingQuestion;
procedure SetTestOptionsDefault;
procedure SetDBOptionsDefault;
procedure RegExtensions(Dir: string);

implementation

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ToolWin, ComCtrls, Menus, IniFiles, ExtDlgs, ExtCtrls,
  StdCtrls, CheckLst, MainTestUnit, TestTypesConstantsVariables,
  CurrentAnswerVariantEditingFormUnit, CurrentTestOptionsFormUnit,
  DatabaseOptionsFormUnit, ExportToFormUnit, MediaPlayerFormUnit,
  PasswordDLGUnit, ShowQuestionNFormUnit, TestOptionsFormUnit,
  CallUserNameFormUnit, DatabaseShowingFormUnit, DeleteAnswerNFormUnit,
  DeleteQuestionNFormUnit, ShowAnswerNFormUnit, TestingResultsFormUnit,
  AboutEditableTestFormUnit, StartingTestFormUnit, PasswordWondersUnit,
  HighScoresUnit, HowToOpenFormUnit, OptionsPasswordFormUnit, MMSystem, Registry,
  DBorHSExportToFormUnit;

{function RunningAsAdministrator (): Boolean;
var
 SystemSidAuthority: (SID_IDENTIFIER_AUTHORITY = 5{SECURITY_NT_AUTHORITY}{);   }
{ psidAdmin: PSID;
 ptg: (PTTOKEN_GROUPS = 0);
 htkThread: Integer; { HANDLE }
{ cbTokenGroups: Longint; { DWORD }
{ iGroup: Longint; { DWORD }
{ bAdmin: Boolean;
begin
    Result := false;
    if not OpenThreadToken(GetCurrentThread(),      // get security token
                        TOKEN_QUERY,
                        FALSE,
                        htkThread) then
       if GetLastError() = ERROR_NO_TOKEN then
       begin
          if not OpenProcessToken(GetCurrentProcess(),
                               TOKEN_QUERY,
                               htkThread) then
          Exit;
       end
       else
          Exit;
    if GetTokenInformation(htkThread,            // get #of groups
                           TokenGroups,
                           nil,
                           0,
                           cbTokenGroups) then
       Exit;
    if GetLastError() <> ERROR_INSUFFICIENT_BUFFER then
       Exit;
    ptg := PTOKEN_GROUPS( getmem( cbTokenGroups ) );
    if not Assigned(ptg) then
       Exit;
    if not GetTokenInformation(htkThread,           // get groups
                            TokenGroups,
                            ptg,
                            cbTokenGroups,
                            cbTokenGroups) then
       Exit;
    if not AllocateAndInitializeSid(SystemSidAuthority,
                                 2,
                                 SECURITY_BUILTIN_DOMAIN_RID,
                                 DOMAIN_ALIAS_RID_ADMINS,
                                 0, 0, 0, 0, 0, 0,
                                 psidAdmin) then
       Exit;
    iGroup := 0;
    while iGroup < ptg^.GroupCount do // check administrator group
    begin
       if EqualSid(ptg^.Groups[iGroup].Sid, psidAdmin) then
       begin
          Result := TRUE;
          break;
       end;
       Inc( iGroup );
    end;
    FreeSid(psidAdmin);
end;}

procedure SetAllFontAndColor;
begin
  TestMainForm.StatusBar.Color:=BGColor;
  TestMainForm.EditingPanel.Color:=BGColor;
  TestMainForm.TestingPanel.Color:=BGColor;
  TestMainForm.Color:=BGColor;
  TestMainForm.TestingPanel.Color:=BGColor;
  TestMainForm.Font:=ProgFont;
  CurrentAnswerVariantEditingForm.Color:=BGColor;
  CurrentAnswerVariantEditingForm.Font:=ProgFont;
  CurrentTestOptionsForm.Color:=BGColor;
  CurrentTestOptionsForm.Font:=ProgFont;
  DatabaseOptionsForm.Color:=BGColor;
  DatabaseOptionsForm.Font:=ProgFont;
  ExportToForm.Color:=BGColor;
  ExportToForm.Font:=ProgFont;
  MediaPlayerForm.Color:=BGColor;
  MediaPlayerForm.Font:=ProgFont;
  PasswordDLG.Color:=BGColor;
  PasswordDLG.Font:=ProgFont;
  ShowQuestionNForm.Color:=BGColor;
  ShowQuestionNForm.Font:=ProgFont;
  TestOptionsForm.Color:=BGColor;
  TestOptionsForm.Font:=ProgFont;
  CallUserNameForm.Color:=BGColor;
  CallUserNameForm.Font:=ProgFont;
  DatabaseShowingForm.Color:=BGColor;
  DatabaseShowingForm.Font:=ProgFont;
  DatabaseShowingForm.StringGrid.Font:=ProgFont;
  DeleteAnswerNForm.Color:=BGColor;
  DeleteAnswerNForm.Font:=ProgFont;
  DeleteQuestionNForm.Color:=BGColor;
  DeleteQuestionNForm.Font:=ProgFont;
  ShowAnswerNForm.Color:=BGColor;
  ShowAnswerNForm.Font:=ProgFont;
  TestingResultsForm.Color:=BGColor;
  TestingResultsForm.Font:=ProgFont;
  AboutEditableTestForm.Color:=BGColor;
  AboutEditableTestForm.Font:=ProgFont;
  PasswordWondersForm.Color:=BGColor;
  PasswordWondersForm.Font:=ProgFont;
  HighScoresForm.Color:=BGColor;
  HighScoresForm.Font:=ProgFont;
  HowToOpenForm.Color:=BGColor;
  HowToOpenForm.Font:=ProgFont;
  OptionsPasswordForm.Color:=BGColor;
  OptionsPasswordForm.Font:=ProgFont;
  DBorHSExportToForm.Color:=BGColor;
  DBorHSExportToForm.Font:=ProgFont;
end;

procedure SaveUndoRedo;
var i: byte;
begin
  URR.CurrentTestFileOptions:=CurrentTestOptions;
  URR.TestOptions:=TestOptions;
  if Editing then
   if CurrentTestOptions.QuestionsCount>0 then
    for i:=0 to CurrentTestOptions.QuestionsCount-1 do
     URR.Questions[i]:=Questions[i];
end;

procedure RestoreUndoRedo;
var i: byte;
begin
  if Editing then
   with TestMainForm do
    begin
     URR1.Questions[CurrentEditingQuestion].Question:=QuestionTextEdit.Text;
     URR1.Questions[CurrentEditingQuestion].AnsCount:=AnswerVariantsCountSpinEdit.Value;
     URR1.Questions[CurrentEditingQuestion].Answer[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.AnswerVariantTextEdit.Text;
     URR1.Questions[CurrentEditingQuestion].Right[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.RightAnswerCheckBox.Checked;
     URR1.Questions[CurrentEditingQuestion].Balls[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Value;
     URR1.Questions[CurrentEditingQuestion].Comment[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.CommentEdit.Text;
     URR1.Questions[CurrentEditingQuestion].Hint[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.HintEdit.Text;
     URR1.questions[CurrentEditingQuestion].HintMinusBalls[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value;
     if ChoosePictureEdit.Text='<>' then URR1.Questions[CurrentEditingQuestion].PicturePath:='' else
      URR1.Questions[CurrentEditingQuestion].PicturePath:=ChoosePictureEdit.Text;
     if ChooseSoundEdit.Text='<>' then URR1.Questions[CurrentEditingQuestion].SoundPath:='' else
      URR1.Questions[CurrentEditingQuestion].SoundPath:=ChooseSoundEdit.Text;
     URR1.Questions[CurrentEditingQuestion].LoopSound:=LoopSoundCheckBox.Checked;
    end;
  URR1.CurrentTestFileOptions:=CurrentTestOptions;
  URR1.TestOptions:=TestOptions;
  CurrentTestOptions:=URR.CurrentTestFileOptions;
  TestOptions:=URR.TestOptions;
  if CurrentTestOptions.QuestionsCount>0 then
  for i:=0 to CurrentTestOptions.QuestionsCount-1 do
   Questions[i]:=URR.Questions[i];
  URR.CurrentTestFileOptions:=URR1.CurrentTestFileOptions;
  URR.TestOptions:=URR1.TestOptions;
  if Editing then
   if CurrentTestOptions.QuestionsCount>0 then
    for i:=0 to CurrentTestOptions.QuestionsCount-1 do
     URR.Questions[i]:=URR1.Questions[i];
end;

procedure StoreQuestions;
begin
  with TestMainForm do
   begin
    Questions[CurrentEditingQuestion].Question:=QuestionTextEdit.Text;
    Questions[CurrentEditingQuestion].AnsCount:=AnswerVariantsCountSpinEdit.Value;
    Questions[CurrentEditingQuestion].Answer[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.AnswerVariantTextEdit.Text;
    Questions[CurrentEditingQuestion].Right[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.RightAnswerCheckBox.Checked;
    Questions[CurrentEditingQuestion].Balls[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Value;
    Questions[CurrentEditingQuestion].Comment[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.CommentEdit.Text;
    Questions[CurrentEditingQuestion].Hint[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.HintEdit.Text;
    Questions[CurrentEditingQuestion].HintMinusBalls[CurrentEditingAnswer]:=CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value;
    if (ChoosePictureEdit.Text='<>')or(ChoosePictureEdit.Text='') then Questions[CurrentEditingQuestion].PicturePath:='' else
       Questions[CurrentEditingQuestion].PicturePath:=ChoosePictureEdit.Text;
    if (ChooseSoundEdit.Text='<>')or(ChooseSoundEdit.Text='') then Questions[CurrentEditingQuestion].SoundPath:='' else
       Questions[CurrentEditingQuestion].SoundPath:=ChooseSoundEdit.Text;
    Questions[CurrentEditingQuestion].LoopSound:=LoopSoundCheckBox.Checked;
   end;
end;

procedure RestoreQuestions;
begin
  with TestMainForm do
   begin
    if CurrentTestOptions.WithBalls then
     begin
      CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Enabled:=true;
      CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Value:=Questions[CurrentEditingQuestion].Balls[CurrentEditingAnswer];
      if CurrentTestOptions.WithHints then
       begin
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=true;
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=Questions[CurrentEditingQuestion].HintMinusBalls[CurrentEditingAnswer];
       end
      else
       begin
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=false;
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=0;
       end;
     end
    else
     begin
      CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Enabled:=false;
      CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=false;
      CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=0;
      CurrentAnswerVariantEditingForm.BallsForVariantSpinEdit.Value:=0;
     end;
    if CurrentTestOptions.WithMusic then
     begin
      ChooseSoundEdit.Enabled:=true;
      ChooseSoundButton.Enabled:=true;
      if Questions[CurrentEditingQuestion].SoundPath='' then TestMainForm.ChoosesoundEdit.text:='<>' else
       begin
        TestMainForm.ChoosePictureEdit.text:=Questions[CurrentEditingQuestion].SoundPath;
        MediaPlayerForm.Show;
        TestMainForm.Repainting;
        LoopSoundCheckBox.Checked:=Questions[CurrentEditingQuestion].LoopSound;
        PlayParametres:=SND_FILENAME+SND_ASYNC;
        if Questions[CurrentEditingQuestion].LoopSound then PlayParametres:=PlayParametres+SND_LOOP;
        MediaPlayerForm.PlayButtonClick(TestMainForm);
       end;
     end
    else
     begin
      ChooseSoundEdit.Enabled:=false;
      ChooseSoundEdit.Text:='<>';
      MediaPlayerForm.Hide;
      LoopSoundCheckBox.Checked:=false;
      LoopSoundCheckBox.Enabled:=false;
      ChooseSoundButton.Enabled:=false;
     end;
    if CurrentTestOptions.WithPictures then
     begin
      ChoosePictureEdit.Enabled:=true;
      ChoosePictureButton.Enabled:=true;
      if Questions[CurrentEditingQuestion].PicturePath<>'' then
       begin
        ChoosePictureEdit.text:=Questions[CurrentEditingQuestion].PicturePath;
        if Pos('\',Questions[CurrentEditingQuestion].PicturePath)>0 then
         Image.picture.LoadFromFile(Questions[CurrentEditingQuestion].PicturePath)
        else Image.picture.LoadFromFile(TestPath+'\'+Questions[CurrentEditingQuestion].PicturePath)
       end
      else
       begin
        Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
        ChoosePictureEdit.Text:='<>';
       end
      end
    else
     begin
      Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
      ChoosePictureEdit.Enabled:=false;
      ChoosePictureButton.Enabled:=false;
      ChoosePictureEdit.Text:='<>';
     end;
    if CurrentTestOptions.WithHints then
     begin
      if CurrentTestOptions.WithBalls then
       begin
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=Questions[CurrentEditingQuestion].HintMinusBalls[CurrentEditingAnswer];
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=true;
       end
      else
       begin
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=false;
        CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=0;
       end;
      CurrentAnswerVariantEditingForm.HintEdit.Enabled:=true;
      CurrentAnswerVariantEditingForm.HintEdit.Text:=Questions[CurrentEditingQuestion].Hint[CurrentEditingAnswer];
     end
    else
     begin
      CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Enabled:=false;
      CurrentAnswerVariantEditingForm.MinusBallsForUsingHintSpinEdit.Value:=0;
      CurrentAnswerVariantEditingForm.HintEdit.Enabled:=false;
      CurrentAnswerVariantEditingForm.HintEdit.Text:='';
     end;
    if CurrentTestOptions.WithComments then
     begin
      CurrentAnswerVariantEditingForm.CommentEdit.Enabled:=true;
      CurrentAnswerVariantEditingForm.CommentEdit.Text:=Questions[CurrentEditingQuestion].Comment[CurrentEditingAnswer];
     end
    else
     begin
      CurrentAnswerVariantEditingForm.CommentEdit.Enabled:=false;
      CurrentAnswerVariantEditingForm.CommentEdit.Text:='';
     end;
    if CurrentEditingQuestion = 0 then TestMainForm.PreviousQuestionButton.Enabled:=false else TestMainForm.PreviousQuestionButton.Enabled:=true;
    if CurrentEditingQuestion = CurrentTestOptions.QuestionsCount-1 then TestMainForm.NextQuestionButton.Enabled:=false else TestMainForm.NextQuestionButton.Enabled:=true;
    if CurrentEditingAnswer=0 then TestMainForm.PreviousAnswerVariantButton.Enabled:=false else TestMainForm.PreviousAnswerVariantButton.Enabled:=true;
    if CurrentEditingAnswer=Questions[CurrentEditingQuestion].AnsCount-1 then TestMainForm.NextAnswerVariantButtonButton.Enabled:=false else TestMainForm.NextAnswerVariantButtonButton.Enabled:=true;
    TestFileTopicLabel.Caption:=CurrentTestOptions.TopicName;
    TestMainForm.NumberOfQuestionLabel.Caption:=IntToStr(1+CurrentEditingQuestion)+' ';
    TestMainForm.NumberOfAnswerVariantLabel.Caption:=IntToStr(1+CurrentEditingAnswer)+'  ';
    QuestionTextEdit.Text:=Questions[CurrentEditingQuestion].Question;
    AnswerVariantsCountSpinEdit.Value:=Questions[CurrentEditingQuestion].AnsCount;
    CurrentAnswerVariantEditingForm.AnswerVariantTextEdit.Text:=Questions[CurrentEditingQuestion].Answer[CurrentEditingAnswer];
    CurrentAnswerVariantEditingForm.RightAnswerCheckBox.Checked:=Questions[CurrentEditingQuestion].Right[CurrentEditingAnswer];
    NumberOfQuestionLabel.Caption:=IntToStr(CurrentEditingQuestion+1)+' ';
    NumberOfAnswerVariantLabel.Caption:=IntToStr(CurrentEditingAnswer+1)+'  ';
    if CurrentTestOptions.TopicName <> '' then
     TestMainForm.Caption:=CurrentTestOptions.TopicName+' - Mental Control'
    else TestMainForm.Caption:='<   > - Mental Control';
    Application.Title:=TestMainForm.Caption;
   end;
end;

procedure ShowTestingQuestion;
var
  i: word;
  MaxWidth: integer;
  s: string;
begin
  with TestMainForm do
   begin
    if (not CurrentTestOptions.WithPictures)or(Questions[CurrentAnsweringQuestion].PicturePath='')
    then Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath) else
    if Questions[CurrentAnsweringQuestion].PicturePath<>'' then
     begin
      ChoosePictureEdit.text:=Questions[CurrentAnsweringQuestion].PicturePath;
      if Pos('\',Questions[CurrentAnsweringQuestion].PicturePath)>0 then
       Image.picture.LoadFromFile(Questions[CurrentAnsweringQuestion].PicturePath)
      else Image.picture.LoadFromFile(TestPath+'\'+Questions[CurrentAnsweringQuestion].PicturePath)
     end
    else
     Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath);
    s:=Questions[CurrentAnsweringQuestion].SoundPath;
    PlayParametres:=SND_FILENAME+SND_ASYNC;
    if Questions[CurrentAnsweringQuestion].LoopSound then PlayParametres:=PlayParametres+SND_LOOP;
    AnswerVariantsCheckListBox.Height:=TestLBHeight-QuestionTextLabel.Height;
    AnswerVariantsCheckListBox.Top:=TestLBTop+QuestionTextLabel.Height;
    AnswerVariantsCheckListBox.Items.Clear;
    for i:=0 to Questions[CurrentAnsweringQuestion].AnsCount-1 do
     begin
      AnswerVariantsCheckListBox.Items.Add(Questions[CurrentAnsweringQuestion].Answer[i]);
      AnswerVariantsCheckListBox.Checked[i]:=false;
     end;
    if CurrentTestOptions.WithMusic then PlaySound(PChar(s),0,PlayParametres);
    for I:=0 to Questions[CurrentAnsweringQuestion].AnsCount-1 do
     AnswerVariantsCheckListBox.Checked[i]:= Questions[CurrentAnsweringQuestion].Answered[i];
    MaxWidth := 0;
    for i := 0 to AnswerVariantsCheckListBox.Items.Count - 1 do
      if MaxWidth < AnswerVariantsCheckListBox.Canvas.TextWidth(AnswerVariantsCheckListBox.Items.Strings[i]) then
        MaxWidth := AnswerVariantsCheckListBox.Canvas.TextWidth(AnswerVariantsCheckListBox.Items.Strings[i]);
   SendMessage(AnswerVariantsCheckListBox.Handle, LB_SETHORIZONTALEXTENT, MaxWidth*2+ProgFont.Size*2, 0);
   end;
end;

procedure SetTestOptionsDefault;
begin
  BGColor:=$00A0A0A0;
  ProgFont.Name:='MS Sans Serif';
  ProgFont.Size:=10;
  ProgFont.Charset:=RUSSIAN_CHARSET;
  ProgFont.Style:=[];
  ProgFont.Pitch:=fpDefault;
  ProgFont.Color:=0;
  TestOptions.BackgroundBitmapFilePath:=ExtractFilePath(ParamStr(0))+'\Mcw32EIOperation.ico';
  TestOptions.ToLimitTestTime:=false;
  TestOptions.BackWindowGroundColor:=BGColor;
  with TestOptions.BackGroungFont do
   begin
    Charset:=ProgFont.Charset;
    Color:=ProgFont.Color;
    Height:=ProgFont.Height;
    Name:=ProgFont.Name;
    Pitch:=ProgFont.Pitch;
    PixelsPerInch:=ProgFont.PixelsPerInch;
    Size:=ProgFont.Size;
    Style:=ProgFont.Style;
   end;
end;

procedure SetDBOptionsDefault;
begin
  TestOptions.ToAddAllResultsToDatabase:=true;
  TestOptions.ToCallUserNameFoEveryTesting:=true;
  TestOptions.ToShowDatabaseAfterEveryTesting:=true;
  TestOptions.ToCreateHighscoresList:=false;
end;

procedure RegPassword(const Psswrd: string); export;
var
{ h: HKEY;
begin
  if RegCreateKey(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot create reg key Psswrds');
    Exit;
   end;
  if RegSetValue(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',REG_SZ,PChar(psswrd),length(psswrd))<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot reg value '+Psswrd);
    Exit;
   end;
  if RegCloseKey(h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot close registry');
    Exit;
   end;}
  r: TRegIniFile;
begin
  R:=TRegIniFile.Create('');
  r.RootKey:=HKEY_CURRENT_USER;
  r.WriteString('SOFTWARE\Mental Control\Psswrds','',psswrd);
  r.CloseKey;
  r.Free;
end;

function LoadPassword: string; export;
var
{  h: HKEY;
  p: PChar;
  r: integer;
begin
  r:=0;
  New(p);
  if RegOpenKey(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot open reg key Psswrds');
    Exit;
   end;
  if RegQueryValue(HKEY_LOCAL_MACHINE,'SOFTWARE\Mental Control\Psswrds',P,r)<>ERROR_SUCCESS then
    begin
     ShowMessage('Cannot open reg value');
     Exit;
    end;
  if RegCloseKey(h)<>ERROR_SUCCESS then
   begin
    ShowMessage('Cannot close registry');
    Exit;
   end;
  Dispose(p);}
  r: TRegIniFile;
begin
  R:=TRegIniFile.Create('');
  r.RootKey:=HKEY_CURRENT_USER;
  Result:=r.ReadString('SOFTWARE\Mental Control\Psswrds','','');
  r.Free;
end;

function PasswordExisting: boolean; export;
var
  h: HKEY;
begin
  Result:=RegOpenKey(HKEY_CURRENT_USER,'SOFTWARE\Mental Control\Psswrds',h)=ERROR_SUCCESS;
end;

procedure RegExtensions(Dir: string); export;
var
  R : TRegIniFile;
begin
  R := TRegIniFile.Create('');
  with R do
   begin
    RootKey := HKEY_CLASSES_ROOT;
    WriteString('.mct','',' Mental Control');
    WriteString(' Mental Control','',' Mental Control');
    WriteString(' Mental Control\DefaultIcon','',Dir+',2');
    WriteString('.tfd','','  Mental Control');
    WriteString('  Mental Control','',' Mental Control');
    WriteString('  Mental Control\DefaultIcon','',Dir+',1');
    Free;
   end;
end;

procedure SetRU; export;
var
  Layout: array[0.. KL_NAMELENGTH] of char;
begin
  LoadKeyboardLayout( StrCopy(Layout,'00000419'),KLF_ACTIVATE);
end;

procedure SetEN; export;
var
  Layout: array[0.. KL_NAMELENGTH] of char;
begin
  LoadKeyboardLayout(StrCopy(Layout,'00000409'),KLF_ACTIVATE);
end;


end.
