{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit TestTypesConstantsVariables;

interface

uses IniFiles, Graphics, Forms, Registry;

type TTestQuestion=class
 public
  constructor Create;
 protected
  PicturePath, SoundPath: string[255];
  AnsCount: byte;
  Question: string;
  Answer: array of string;
  Balls: array of word;
  LoopSound: boolean;
  Right, Answered: array of byte;
end;

type TTestRecord = record
  PicturePath, SoundPath: string[255];
  AnsCount: byte;
  Question: string[255];
  Answer, Comment, Hint: array[0..24] of string[255];
  Balls, HintMinusBalls: array[0..24] of word;
  LoopSound: boolean;
  Answered: array[0..24] of boolean;
  Right: array[0..24] of boolean;
end;

type TTestOptions = record
  ToLimitTestTime: Boolean;
  MaxTestTime: word;
  BackgroundBitmapFilePath: string[255];
  BackGroungFont: record
   Charset: TFontCharSet;
   Color: TColor;
   Height: Integer;
   Name: string[255];
   Pitch: TFontPitch;
   PixelsPerInch: Integer;
   Size: Integer;
   Style: TFontStyles;
  end;
  BackWindowGroundColor: TColor;
  ToAddAllResultsToDatabase, ToAllowChangeDatabaseWithoutPassword,
  ToCreateHighscoresList, ToShowDatabaseAfterEveryTesting,
  ToCallUserNameFoEveryTesting, ToCreateStatisticsForEveryTestedUser: boolean;
  MainWindowState: TWindowState;
  MainWindowTop, MainWindowLeft, MainWindowHeight,
  MainWindowWidth, MainWindowClienHeight,
  MainWindowClientWidth: word;
end;

type TCurrentTestFileOptions = record
  WithPictures, WithMusic, WithBalls: boolean;
  Password: string[255];
  QuestionsCount: word;
  AnswerOnlyByOrderOfQuestions: boolean;
  ShowAllOfTheQuestionsOnce: boolean;
  TopicName: string[255];
  WithHints,WithComments: boolean;
end;

type TDataBaseRecord = record
  Name, Suname, Classx, Topic: string[255];
  RightAnswers, MaxRightAnswersCount: word;
  ReachedBalls: longint;
end;

type THighScoresRecord = record
  Name, Suname, Classx, Topic: string[255];
  RightAnswers, MaxRightAnswersCount: word;
  ReachedBalls: longint;
  PercentRight: extended;
end;

type TUndoRedoRecord = record
  Questions: array[0..255] of TTestRecord;
  CurrentTestFileOptions: TCurrentTestFileOptions;
  TestOptions: TTestOptions;

end;
  TestFile = file of TTestRecord;
  OptionsFile = file of TTestOptions;
  CurrentFileOptionsFile = file of TCurrentTestFileOptions;
  TestDatabaseFile = file of TDataBaseRecord;
  HighScoresFile = file of THighScoresRecord;

const
  TEST_REG_DLL='RegistryServices.dll';
  TEST_LANG_DLL='LanguageServices.dll';

var
  Opened, Edited: boolean;
  Timers: array[1..4] of longword;
  El_Time, P_Time: Int64;
  Questions, Qu, Que: array of TTestRecord;
  TestOptions, TestOptions1: TTestOptions;
  Testing, Editing, Paused: boolean;
  CurrentTestOptions, CurrentTestOptions1, CurrentTestOptions2: TCurrentTestFileOptions;
  Passwords: array[1..20] of boolean;
  TestPath, TestPass: string;
  CurrentEditingQuestion, CurrentEditingAnswer,
  CurrentAnsweringQuestion: word;
  PlayParametres: Cardinal;
  SaveTo: string;
  ProgFont: TFont;
  BGColor: TColor;
  AllBalls, UsedHintsBalls, RightAnswers, AllTrue: longint;
  CurrentSelectedAnswer: word;
  TestLBTop, TestLBHeight: word;
  ReadyDir: boolean;
  CurrentTestingResults, CTR1: TDataBaseRecord;
  HighScores, HSCR1: array[1..10] of THighScoresRecord;
  HSCR2, HSCR3: THighScoresRecord;
  StartingCounts: longword;
  HowToOpen_OpenToTest, Opened_By_ParamStr_Once: boolean;
  URR, URR1: TUndoRedoRecord;
  IfIsFirst, RegPsswrdCommand: boolean;
  MRCTOF, ShowingWarningOfPsswrds: boolean;
  TestRG: TRegistry;
  SenderOfExportDBHS: byte;

implementation

constructor  TTestQuestion.Create;
begin
end;

end.
