{------------------------------------------}
{Mental Control 1.0}
{    }
{Open Source under MPL}
{(c) 2003 SF}
{------------------------------------------}

unit TestingResultsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MMSystem;

type
  TTestingResultsForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ShowCommentsAndResultsButton: TButton;
    OKButton: TButton;
    RightAnswersCountLabel: TLabel;
    ReachedBallsLabel: TLabel;
    procedure OKButtonClick(Sender: TObject);
    procedure ShowCommentsAndResultsButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestingResultsForm: TTestingResultsForm;

implementation

uses MainTestUnit, TestTypesConstantsVariables, DatabaseShowingFormUnit;

{$R *.dfm}

procedure TTestingResultsForm.OKButtonClick(Sender: TObject);
begin
  with TestMainForm do
   begin
    AnswerVariantsCheckListBox.Hide;
    APreviousQuestionButton.Hide;
    ANextQuestionButton.Hide;
    ShowHintButton.Hide;
    ReadyButton.Hide;
    EnoughButton.Hide;
    ShowCommentButton.Hide;
    QuestionTextLabel.Caption:='  ,  '+#13+'  !'+#13+' .';
   end;
  TestMainForm.AnswerVariantsCheckListBox.Top:=TestLBTop;
  TestMainForm.AnswerVariantsCheckListBox.Height:=TestLBHeight;
  TestMainForm.Image.Picture.LoadFromFile(testOptions.BackgroundBitmapFilePath);
  Close;
 if TestOptions.ToShowDatabaseAfterEveryTesting then TestMainForm.ShowDatabase1Click(self);
end;

procedure TTestingResultsForm.ShowCommentsAndResultsButtonClick(
  Sender: TObject);
var
 i: word;
 s: string;
begin
  TestMainForm.ShowCommentButton.Left:=TestMainForm.ShowHintButton.Left;
  TestMainForm.ShowCommentButton.Top:=TestMainForm.ShowHintButton.Top;
  TestMainForm.EnoughButton.Left:=TestMainForm.ReadyButton.Left;
  TestMainForm.EnoughButton.Top:=TestMainForm.ReadyButton.Top;
  TestMainForm.SNextAnswerButton.Left:=TestMainForm.ANextQuestionButton.Left;
  TestMainForm.SNextAnswerButton.Top:=TestMainForm.ANextQuestionButton.Top;
  TestMainForm.SNextAnswerButton.Visible:=true;
  TestMainForm.SPreviousAnswerButton.Left:=TestMainForm.APreviousQuestionButton.Left;
  TestMainForm.SPreviousAnswerButton.Top:=TestMainForm.APreviousQuestionButton.Top;
  TestMainForm.SPreviousAnswerButton.Visible:=true;
  TestMainForm.ShowCommentButton.Show;
  TestMainForm.ANextQuestionButton.Enabled:=true;
  TestMainForm.ANextQuestionButton.Hide;
  TestMainForm.APreviousQuestionButton.Enabled:=true;
  TestMainForm.APreviousQuestionButton.Hide;
  TestMainForm.EnoughButton.Show;
  TestMainForm.ShowHintButton.Hide;
  TestMainForm.ReadyButton.Hide;
  with TestMainForm do
   begin
    if (not CurrentTestOptions.WithPictures)or(Questions[CurrentAnsweringQuestion].PicturePath='')
    then Image.Picture.LoadFromFile(TestOptions.BackgroundBitmapFilePath) else
      Image.Picture.LoadFromFile(Questions[CurrentAnsweringQuestion].PicturePath);
    PlayParametres:=SND_ASYNC+SND_FILENAME;
    if Questions[CurrentEditingQuestion].LoopSound then PlayParametres:=PlayParametres+SND_LOOP;
  QuestionTextLabel.Caption:=WrapText(Questions[CurrentAnsweringQuestion].Question,400 div TestOptions.BackGroungFont.Size);
  if CurrentAnsweringQuestion<CurrentTestOptions.QuestionsCount-1 then
   sNextAnswerButton.Enabled:=True
  else sNextaNSWERButton.Enabled:=False;
  if CurrentAnsweringQuestion>0 then
   SPreviousAnswerButton.Enabled:=True
  else SPreviousAnswerButton.Enabled:=False;
    AnswerVariantsCheckListBox.Height:=TestLBHeight-QuestionTextLabel.Height;
    AnswerVariantsCheckListBox.Top:=TestLBTop+QuestionTextLabel.Height;
    AnswerVariantsCheckListBox.Items.Clear;
    for i:=0 to Questions[CurrentAnsweringQuestion].AnsCount-1 do
     begin
      AnswerVariantsCheckListBox.Items.Add(Questions[CurrentAnsweringQuestion].Answer[i]);
      AnswerVariantsCheckListBox.Checked[i]:=Questions[CurrentAnsweringQuestion].Right[i];
     end;
    if CurrentAnsweringQuestion<CurrentTestOptions.QuestionsCount-1 then
     sNextAnswerButton.Enabled:=True
    else sNextaNSWERButton.Enabled:=False;
    if CurrentTestOptions.WithMusic then PlaySound(PChar(s),0,PlayParametres);
   end;
  Close;
  if TestOptions.ToShowDatabaseAfterEveryTesting then TestMainForm.ShowDatabase1Click(self);
end;

end.
